//
//  AppUpdateWindowController.h
//  AppUpdate
//
//  Created by Jerome Le Saux  on 15/02/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface AppUpdateWindowController : NSWindowController {
	IBOutlet NSTextField * m_description;
	IBOutlet NSButton *m_cancelButton;
	IBOutlet NSButton *m_okButton;
	IBOutlet NSProgressIndicator *m_downloadIndicator;
	IBOutlet NSWindow *m_window;
	IBOutlet NSImageCell* m_appImage;
	IBOutlet NSTextField *m_appName;
	
	
	id _delegate;
	NSString *m_version;
	NSString *m_appIconPath;
	NSURL *m_appUrl;
	NSDictionary *m_informations;
	Boolean m_valideUrl;
	Boolean m_updateDownloading;
	NSURLDownload *m_updateDownload;
	NSURLResponse *m_updateResponse;
	NSMutableData *connectionData;
	NSString *downloadPath;
	unsigned m_downloadBytes;
}

- (id)initWithDelegate:(id)delegate url:(NSString*)url version:(NSString*)version;


- (IBAction)okDownloadNewVersion:(id)sender;
- (IBAction)cancelDownloadNewVersion:(id)sender;

- (BOOL)check;
 
/* Download Management Methods */
- (void)startUpdateDownload:(NSURL *)url;
- (void)endUpdateDownload;
- (void)presentDownloadSuccess;
- (void)presentDownloadError;
- (void)releaseDownloadPath;

/* NSURLDownload Delegate Methods */
- (void)download:(NSURLDownload *)download didReceiveResponse:(NSURLResponse *)response;
- (void)download:(NSURLDownload *)download didReceiveDataOfLength:(unsigned)length;
- (void)downloadDidFinish:(NSURLDownload *)download;
- (void)download:(NSURLDownload *)download didFailWithError:(NSError *)error;


@end
